unit EanFmt3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, EanKod, checklst, ExtCtrls, EanSpecs, ComCtrls;

type
  TEANSetupFmt = class(TForm)
    ZAL: TPageControl;
    SH1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    SH_COPYRIGHT: TTabSheet;
    BtnOk: TBitBtn;
    CBTyp: TComboBox;
    BarCode: TEdit;
    ZNAKY: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    BGColor: TComboBox;
    LinesColor: TComboBox;
    AddUp: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Transparent: TCheckBox;
    StartStopLines: TCheckBox;
    ShowLabels: TCheckBox;
    SecurityZoom: TCheckBox;
    FontAutoSize: TCheckBox;
    L3: TLabel;
    FD: TFontDialog;
    BtnCancel: TBitBtn;
    BtnHelp: TBitBtn;
    BtnApply: TBitBtn;
    BitBtn2: TBitBtn;
    LblAngle: TLabel;
    EdAngle: TEdit;
    UD_Angle: TUpDown;
    TabSheet1: TTabSheet;
    MaskDigit: TCheckListBox;
    Label6: TLabel;
    EANMEMO: TMemo;
    CO: TColorDialog;
    Ean1: TEan;
    Ean2: TEan;
    Image1: TImage;
    EAN: TEan;
    EanMemo1: TEanMemo;
    TabSheet4: TTabSheet;
    GR_Caption: TGroupBox;
    CA_Alignment: TComboBox;
    L4: TLabel;
    CA_AutoCaption: TCheckBox;
    CA_AutoSize: TCheckBox;
    L2: TLabel;
    Label7: TLabel;
    CA_Font: TLabel;
    FONT_UP: TBitBtn;
    EAN_Font: TLabel;
    L1: TLabel;
    Label8: TLabel;
    EAN_Width: TEdit;
    EAN_Height: TEdit;
    UD_Width: TUpDown;
    UD_Height: TUpDown;
    TabSheet5: TTabSheet;
    BitBtn3: TBitBtn;
    SD: TSaveDialog;
    CA_Visible: TCheckBox;
    BCA_Visible: TCheckBox;
    BGR_CAPTION: TGroupBox;
    BCA_FONT: TLabel;
    BCA_Alignment: TComboBox;
    BCA_AutoCaption: TCheckBox;
    BCA_AutoSize: TCheckBox;
    BCA_TEXT: TEdit;
    FONT_DOWN: TBitBtn;
    CA_TEXT: TEdit;
    procedure CBTypChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TransparentClick(Sender: TObject);
    procedure BGColorDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BGColorChange(Sender: TObject);
    procedure LinesColorChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BarCodeChange(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnOkClick(Sender: TObject);
    procedure BtnApplyClick(Sender: TObject);
    procedure CA_VisibleClick(Sender: TObject);
    procedure CA_AutoCaptionClick(Sender: TObject);
    procedure FONT_UPClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    ParentEAN        : TCustomEAN;
    procedure UpdateParentEAN;
  public
    procedure SetSelectedCaption(C:TBarcodeCaption);
    procedure SetParentEAN(E:TCustomEAN);
  end;

var
  EANSetupFmt: TEANSetupFmt;

implementation

{$R *.DFM}

var MyColors : array[0..16] of TIdentMapEntry = (
    (Value: clBlack;   Name: 'Black'),
    (Value: clMaroon;  Name: 'Maroon'),
    (Value: clGreen;   Name: 'Green'),
    (Value: clOlive;   Name: 'Olive'),
    (Value: clNavy;    Name: 'Navy'),
    (Value: clPurple;  Name: 'Purple'),
    (Value: clTeal;    Name: 'Teal'),
    (Value: clGray;    Name: 'Gray'),
    (Value: clSilver;  Name: 'Silver'),
    (Value: clRed;     Name: 'Red'),
    (Value: clLime;    Name: 'Lime'),
    (Value: clYellow;  Name: 'Yellow'),
    (Value: clBlue;    Name: 'Blue'),
    (Value: clFuchsia; Name: 'Fuchsia'),
    (Value: clAqua;    Name: 'Aqua'),
    (Value: clWhite;   Name: 'White'),
    (Value: 0;         Name: 'User color'));

function IndexMyColor(Color:TColor):Integer;
var i:Integer;
begin
    Result := High(MyColors);
    for i:=Low(MyColors) to High(MyColors)-1 do
        if MyColors[i].Value=Color then begin
           Result := i;
           Exit;
        end;

end;

procedure TEANSetupFmt.CBTypChange(Sender: TObject);
begin
     EAN.TypBarCode := TTypBarCode(CBTyp.ItemIndex);
     BarCode.Text   := Ean.BarCode;
     AddUp.Visible  := (EAN.TypBarCode=bcEan13);
     ZNAKY.Caption  := EAN.GetSetOfCharsVisible;
end;

procedure TEANSetupFmt.FormCreate(Sender: TObject);
var i:Integer;
begin
     ZAL.ActivePage  := SH1;
     EAN.AddTypesToList(CBTyp.Items,btText);
     CBTyp.ItemIndex := 1;
     EAN.TypBarCode  := bcEan13;
     BarCode.Text    := EAN.BarCode;

     BGColor.Items.Clear;
     for i:= Low(MyColors) to High(MyColors) do
         BGColor.Items.Add(MyColors[i].Name);
     LinesColor.Items.Assign(BGColor.Items);

     BGColor.ItemIndex    :=15;
     LinesColor.ItemIndex :=1 ;

     ZNAKY.Caption  := EAN.GetSetOfCharsVisible;
end;

procedure TEANSetupFmt.TransparentClick(Sender: TObject);
begin
     if Sender=Transparent    then EAN.Transparent           := Transparent.Checked;
     if Sender=FontAutoSize   then EAN.FontAutoSize          := FontAutoSize.Checked;
     if Sender=StartStopLines then EAN.StartStopLines        := StartStopLines.Checked;
     if Sender=ShowLabels     then EAN.ShowLabels            := ShowLabels.Checked;
     if Sender=SecurityZoom   then EAN.Security              := SecurityZoom.Checked;
end;

procedure TEANSetupFmt.BGColorDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var ARect : TRect;
    Text  : array[0..255] of Char;
    Old   : TColor;
begin
  ARect := Rect;
  Inc(ARect.Top, 2);
  Inc(ARect.Left, 2);
  Dec(ARect.Bottom, 2);
  ARect.Right := ARect.Left + 50;

  with TComboBox(Control).Canvas do begin
    FillRect(Rect);
    Old := Brush.Color;
    Pen.Color   := clWindowText;
    Rectangle(ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
    Brush.Color := MyColors[Index].Value;
    Brush.Style := bsSolid;
    try
      InflateRect(ARect, -1, -1);
      FillRect(ARect);
    finally
      Brush.Color := Old;
    end;

    StrPCopy(Text, MyColors[Index].Name);
    Rect.Left := Rect.Left + 60;
    DrawText(Handle, Text, StrLen(Text), Rect,
{$IFDEF RX_D4}
    DrawTextBiDiModeFlags(DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX));
{$ELSE}
    DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
{$ENDIF}
  end;
end;

procedure TEANSetupFmt.BGColorChange(Sender: TObject);
begin
     if TComboBox(Sender).ItemIndex = High(MyCOlors) then begin
        CO.Color := MyColors[High(MyColors)].Value;
        if CO.Execute then begin
           MyColors[High(MyColors)].Value := CO.Color;
        end;
     end;
end;

procedure TEANSetupFmt.LinesColorChange(Sender: TObject);
begin
     EAN.LinesColor := MyColors[TComboBox(Sender).ItemIndex].Value;
end;

procedure TEANSetupFmt.BitBtn2Click(Sender: TObject);
begin
     FD.Font.Assign(EAN_FONT.Font);
     if FD.Execute then
        EAN_Font.Font.Assign(FD.Font);
end;

procedure TEANSetupFmt.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caFree;
end;


procedure TEANSetupFmt.SetParentEAN(E:TCustomEAN);
var i:Integer;
begin
     ParentEAN            := E;

     CBTyp.ItemIndex      := Integer(E.TypBarCode);
     if E is TEanMemo then begin
         EanMemo.Clear;
         EanMemo.Lines.Assign(TEanMemo(E).Lines);
         EanMemo.Visible      := true;
         BarCode.Visible      := false;
     end else begin
         BarCode.Text         := E.BarCode;
         EanMemo.Visible      := false;
         BarCode.Visible      := true;
     end;
     AddUp.Checked        := E.Ean13AddUp;
     BGColor.ItemIndex    := IndexMyColor(E.BackgroundColor);
     LinesColor.ItemIndex := IndexMyColor(E.LinesColor);
     Transparent.Checked  := E.Transparent;
     FontAutoSize.Checked := E.FontAutoSize;
     EAN_FONT.Font.Assign(E.Font);

     StartStopLines.Checked  := E.StartStopLines;
     ShowLabels.Checked      := E.ShowLabels;
     SecurityZoom.Checked    := E.Security;

     UD_Angle.Position       := E.Angle;
     UD_Width.Position       := E.Width;
     UD_Height.Position      := E.Height;

     MaskDigit.Clear;
     for i:=1 to 50 do begin
         MaskDigit.Items.Add(Format('%2d. digit',[i]));
         MaskDigit.Checked[i-1] := (E.DigitVisible(i));
     end;

     AddUp.Visible  := (E.TypBarCode=bcEan13);

     CA_Visible.Checked      := E.Caption.Visible;
     GR_CAPTION.Visible      := E.Caption.Visible;
     CA_AutoSize.Checked     := E.Caption.AutoSize;
     CA_AutoCaption.Checked  := E.Caption.AutoCaption;
     CA_TEXT.Text            := E.Caption.Text;
     CA_ALIGNMENT.ItemIndex  := Integer(E.Caption.Alignment);
     CA_FONT.Font.Assign(E.Caption.Font);

     BCA_Visible.Checked      := E.CaptionBottom.Visible;
     BGR_CAPTION.Visible      := E.CaptionBottom.Visible;
     BCA_AutoSize.Checked     := E.CaptionBottom.AutoSize;
     BCA_AutoCaption.Checked  := E.CaptionBottom.AutoCaption;
     BCA_TEXT.Text            := E.CaptionBottom.Text;
     BCA_ALIGNMENT.ItemIndex  := Integer(E.CaptionBottom.Alignment);
     BCA_FONT.Font.Assign(E.CaptionBottom.Font);
end;

procedure TEANSetupFmt.BarCodeChange(Sender: TObject);
begin
     EAN.BarCode := BarCode.Text;
end;

procedure TEANSetupFmt.BtnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TEANSetupFmt.BtnOkClick(Sender: TObject);
begin
     UpdateParentEAN;
     Close;
end;

procedure TEANSetupFmt.UpdateParentEAN;
var i:Integer;
    s:String;
begin
     if ParentEAN=nil then Exit;

     ParentEAN.TypBarCode := TTypBarCode(CBTyp.ItemIndex);

     if ParentEAN is TEanMemo then begin
         TEanMemo(ParentEAN).Lines.Clear;
         TEanMemo(ParentEAN).Lines.Assign(EanMemo.Lines);
     end else begin
         ParentEAN.BarCode        := BarCode.Text;
     end;

     ParentEAN.EAN13AddUp         := AddUp.Checked;

     ParentEAN.BackgroundColor := MyColors[BGColor.ItemIndex].Value;
     ParentEAN.LinesColor      := MyColors[LinesColor.ItemIndex].Value;
     ParentEAN.Transparent     := Transparent.Checked;
     ParentEAN.Font.Assign(EAN_FONT.Font);
     ParentEAN.FontAutoSize    := FontAutoSize.Checked;

     ParentEAN.StartStopLines := StartStopLines.Checked;
     ParentEAN.ShowLabels     := ShowLabels.Checked;
     ParentEAN.Security       := SecurityZoom.Checked;

     s:='';
     for i:=1 to 50 do begin
         if MaskDigit.Checked[i-1] then  s:=s+'_'
         else                            s:=s+' ';
     end;
     ParentEAN.LabelMask := s;

     ParentEAN.Width := UD_Width.Position;
     ParentEAN.Height:= UD_Height.Position;
     ParentEAN.Angle := UD_Angle.Position;

     with ParentEAN.Caption do begin
          Visible     := CA_Visible.Checked;
          AutoCaption := CA_AutoCaption.Checked;
          AutoSize    := CA_AutoSize.Checked;
          Font.Assign(CA_FONT.FONT);
          Text        := CA_TEXT.Text;
          Alignment   := TAlignment(CA_ALIGNMENT.ItemIndex);
     end;
     with ParentEAN.CaptionBottom do begin
          Visible     := BCA_Visible.Checked;
          AutoCaption := BCA_AutoCaption.Checked;
          AutoSize    := BCA_AutoSize.Checked;
          Font.Assign(BCA_FONT.FONT);
          Text        := BCA_TEXT.Text;
          Alignment   := TAlignment(BCA_ALIGNMENT.ItemIndex);
     end;

end;


procedure TEANSetupFmt.BtnApplyClick(Sender: TObject);
begin
     UpdateParentEAN;
end;


procedure TEANSetupFmt.CA_VisibleClick(Sender: TObject);
begin
     GR_Caption.Visible  := CA_Visible.Checked;
     BGR_Caption.Visible := BCA_Visible.Checked;
end;

procedure TEANSetupFmt.CA_AutoCaptionClick(Sender: TObject);
begin
     CA_TEXT.Enabled:= not CA_AutoCaption.Checked;
end;

procedure TEANSetupFmt.FONT_UPClick(Sender: TObject);
begin
  if Sender=FONT_UP then begin
     FD.Font.Assign(CA_FONT.Font);
     if FD.Execute then
        CA_FONT.Font.Assign(FD.Font);
  end;
  if Sender=FONT_DOWN then begin
     FD.Font.Assign(BCA_FONT.Font);
     if FD.Execute then
        BCA_FONT.Font.Assign(FD.Font);
  end;

end;

procedure TEANSetupFmt.BitBtn3Click(Sender: TObject);
begin
     if SD.Execute then
        ParentEAN.ExportToHTML(SD.FileName, gtjpeg);
end;

procedure TEANSetupFmt.SetSelectedCaption(C:TBarcodeCaption);
begin
end;


end.
